package com.domemusictechnologies.bullybeef;


import voltage.controllers.*;
import voltage.core.*;
import voltage.core.Jack.JackType;
import voltage.sources.*;
import voltage.utility.*;
import voltage.processors.*;
import voltage.effects.*;
import java.awt.*;

//[user-imports]   Add your own imports here
//[/user-imports]


public class BullyBeef extends VoltageModule
//[user-inheritance]
//[/user-inheritance]
{

public BullyBeef( long moduleID, VoltageObjects voltageObjects )
{
   super( moduleID, voltageObjects, "Bully Beef", ModuleType.ModuleType_Oscillators, 2.0 );

   InitializeControls();


   canBeBypassed = true;
   SetSkin( "9ddd69d9e75e4cbab5361cf68ceeb928" );
}

void InitializeControls()
{

   textLabel1 = new VoltageLabel( "textLabel1", "textLabel1", this, "Bully Beef" );
   AddComponent( textLabel1 );
   textLabel1.SetWantsMouseNotifications( false );
   textLabel1.SetPosition( 23, 0 );
   textLabel1.SetSize( 99, 16 );
   textLabel1.SetEditable( false, false );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel1.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel1.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel1.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel1.SetBorderSize( 1 );
   textLabel1.SetMultiLineEdit( false );
   textLabel1.SetIsNumberEditor( false );
   textLabel1.SetNumberEditorRange( 0, 100 );
   textLabel1.SetNumberEditorInterval( 1 );
   textLabel1.SetNumberEditorUsesMouseWheel( false );
   textLabel1.SetHasCustomTextHoverColor( false );
   textLabel1.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel1.SetFont( "Verdana", 14, true, false );

   textLabel2 = new VoltageLabel( "textLabel2", "textLabel2", this, "Dome Music Technologies" );
   AddComponent( textLabel2 );
   textLabel2.SetWantsMouseNotifications( false );
   textLabel2.SetPosition( 12, 340 );
   textLabel2.SetSize( 120, 20 );
   textLabel2.SetEditable( false, false );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel2.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel2.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel2.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel2.SetBorderSize( 1 );
   textLabel2.SetMultiLineEdit( false );
   textLabel2.SetIsNumberEditor( false );
   textLabel2.SetNumberEditorRange( 0, 100 );
   textLabel2.SetNumberEditorInterval( 1 );
   textLabel2.SetNumberEditorUsesMouseWheel( false );
   textLabel2.SetHasCustomTextHoverColor( false );
   textLabel2.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel2.SetFont( "Verdana", 10, false, false );

   switchOctave = new VoltageSwitch( "Octave Switch", "Octave Switch", this, 1 );
   AddComponent( switchOctave );
   switchOctave.SetWantsMouseNotifications( false );
   switchOctave.SetPosition( 6, 45 );
   switchOctave.SetSize( 32, 32 );
   switchOctave.SetSkin( "3-State Bar Vertical" );

   textLabel3 = new VoltageLabel( "textLabel3", "textLabel3", this, "Octave" );
   AddComponent( textLabel3 );
   textLabel3.SetWantsMouseNotifications( false );
   textLabel3.SetPosition( 0, 23 );
   textLabel3.SetSize( 47, 30 );
   textLabel3.SetEditable( false, false );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel3.SetColor( new Color( 226, 79, 166, 255 ) );
   textLabel3.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel3.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel3.SetBorderSize( 1 );
   textLabel3.SetMultiLineEdit( false );
   textLabel3.SetIsNumberEditor( false );
   textLabel3.SetNumberEditorRange( 0, 100 );
   textLabel3.SetNumberEditorInterval( 1 );
   textLabel3.SetNumberEditorUsesMouseWheel( false );
   textLabel3.SetHasCustomTextHoverColor( false );
   textLabel3.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel3.SetFont( "Verdana", 12, false, false );

   textLabel31 = new VoltageLabel( "textLabel31", "textLabel31", this, "Phase" );
   AddComponent( textLabel31 );
   textLabel31.SetWantsMouseNotifications( false );
   textLabel31.SetPosition( 56, 184 );
   textLabel31.SetSize( 35, 23 );
   textLabel31.SetEditable( false, false );
   textLabel31.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel31.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel31.SetColor( new Color( 248, 150, 65, 255 ) );
   textLabel31.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel31.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel31.SetBorderSize( 1 );
   textLabel31.SetMultiLineEdit( false );
   textLabel31.SetIsNumberEditor( false );
   textLabel31.SetNumberEditorRange( 0, 100 );
   textLabel31.SetNumberEditorInterval( 1 );
   textLabel31.SetNumberEditorUsesMouseWheel( false );
   textLabel31.SetHasCustomTextHoverColor( false );
   textLabel31.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel31.SetFont( "Verdana", 12, false, false );

   textLabel4 = new VoltageLabel( "textLabel4", "textLabel4", this, "32'" );
   AddComponent( textLabel4 );
   textLabel4.SetWantsMouseNotifications( false );
   textLabel4.SetPosition( 30, 63 );
   textLabel4.SetSize( 21, 20 );
   textLabel4.SetEditable( false, false );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel4.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel4.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel4.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel4.SetBorderSize( 1 );
   textLabel4.SetMultiLineEdit( false );
   textLabel4.SetIsNumberEditor( false );
   textLabel4.SetNumberEditorRange( 0, 100 );
   textLabel4.SetNumberEditorInterval( 1 );
   textLabel4.SetNumberEditorUsesMouseWheel( false );
   textLabel4.SetHasCustomTextHoverColor( false );
   textLabel4.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel4.SetFont( "Verdana", 10, false, false );

   textLabel5 = new VoltageLabel( "textLabel5", "textLabel5", this, "16'" );
   AddComponent( textLabel5 );
   textLabel5.SetWantsMouseNotifications( false );
   textLabel5.SetPosition( 28, 51 );
   textLabel5.SetSize( 25, 19 );
   textLabel5.SetEditable( false, false );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel5.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel5.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel5.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel5.SetBorderSize( 1 );
   textLabel5.SetMultiLineEdit( false );
   textLabel5.SetIsNumberEditor( false );
   textLabel5.SetNumberEditorRange( 0, 100 );
   textLabel5.SetNumberEditorInterval( 1 );
   textLabel5.SetNumberEditorUsesMouseWheel( false );
   textLabel5.SetHasCustomTextHoverColor( false );
   textLabel5.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel5.SetFont( "Verdana", 10, false, false );

   textLabel6 = new VoltageLabel( "textLabel6", "textLabel6", this, "8'" );
   AddComponent( textLabel6 );
   textLabel6.SetWantsMouseNotifications( false );
   textLabel6.SetPosition( 33, 39 );
   textLabel6.SetSize( 16, 20 );
   textLabel6.SetEditable( false, false );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel6.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel6.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel6.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel6.SetBorderSize( 1 );
   textLabel6.SetMultiLineEdit( false );
   textLabel6.SetIsNumberEditor( false );
   textLabel6.SetNumberEditorRange( 0, 100 );
   textLabel6.SetNumberEditorInterval( 1 );
   textLabel6.SetNumberEditorUsesMouseWheel( false );
   textLabel6.SetHasCustomTextHoverColor( false );
   textLabel6.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel6.SetFont( "Verdana", 10, false, false );

   knobSemitone = new VoltageKnob( "Semitone", "Semitone", this, -12, 12, 0 );
   AddComponent( knobSemitone );
   knobSemitone.SetWantsMouseNotifications( false );
   knobSemitone.SetPosition( 89, 46 );
   knobSemitone.SetSize( 32, 32 );
   knobSemitone.SetSkin( "Dial Plum" );
   knobSemitone.SetRange( -12, 12, 0, false, 25 );
   knobSemitone.SetKnobParams( 215, 145 );
   knobSemitone.DisplayValueInPercent( false );
   knobSemitone.SetKnobAdjustsRing( true );

   textLabel7 = new VoltageLabel( "textLabel7", "textLabel7", this, "Semitone" );
   AddComponent( textLabel7 );
   textLabel7.SetWantsMouseNotifications( false );
   textLabel7.SetPosition( 77, 23 );
   textLabel7.SetSize( 57, 30 );
   textLabel7.SetEditable( false, false );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel7.SetColor( new Color( 226, 79, 166, 255 ) );
   textLabel7.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel7.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel7.SetBorderSize( 1 );
   textLabel7.SetMultiLineEdit( false );
   textLabel7.SetIsNumberEditor( false );
   textLabel7.SetNumberEditorRange( 0, 100 );
   textLabel7.SetNumberEditorInterval( 1 );
   textLabel7.SetNumberEditorUsesMouseWheel( false );
   textLabel7.SetHasCustomTextHoverColor( false );
   textLabel7.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel7.SetFont( "Verdana", 12, false, false );

   switchInterval = new VoltageSwitch( "Osc 2 Interval", "Osc 2 Interval", this, 0 );
   AddComponent( switchInterval );
   switchInterval.SetWantsMouseNotifications( false );
   switchInterval.SetPosition( 6, 97 );
   switchInterval.SetSize( 32, 32 );
   switchInterval.SetSkin( "3-State Bar Vertical" );

   textLabel8 = new VoltageLabel( "textLabel8", "textLabel8", this, "Interval" );
   AddComponent( textLabel8 );
   textLabel8.SetWantsMouseNotifications( false );
   textLabel8.SetPosition( 1, 75 );
   textLabel8.SetSize( 47, 30 );
   textLabel8.SetEditable( false, false );
   textLabel8.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel8.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel8.SetColor( new Color( 226, 79, 166, 255 ) );
   textLabel8.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel8.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel8.SetBorderSize( 1 );
   textLabel8.SetMultiLineEdit( false );
   textLabel8.SetIsNumberEditor( false );
   textLabel8.SetNumberEditorRange( 0, 100 );
   textLabel8.SetNumberEditorInterval( 1 );
   textLabel8.SetNumberEditorUsesMouseWheel( false );
   textLabel8.SetHasCustomTextHoverColor( false );
   textLabel8.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel8.SetFont( "Verdana", 12, false, false );

   textLabel9 = new VoltageLabel( "textLabel9", "textLabel9", this, "Unison" );
   AddComponent( textLabel9 );
   textLabel9.SetWantsMouseNotifications( false );
   textLabel9.SetPosition( 34, 115 );
   textLabel9.SetSize( 34, 20 );
   textLabel9.SetEditable( false, false );
   textLabel9.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel9.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel9.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel9.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel9.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel9.SetBorderSize( 1 );
   textLabel9.SetMultiLineEdit( false );
   textLabel9.SetIsNumberEditor( false );
   textLabel9.SetNumberEditorRange( 0, 100 );
   textLabel9.SetNumberEditorInterval( 1 );
   textLabel9.SetNumberEditorUsesMouseWheel( false );
   textLabel9.SetHasCustomTextHoverColor( false );
   textLabel9.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel9.SetFont( "Verdana", 10, false, false );

   textLabel10 = new VoltageLabel( "textLabel10", "textLabel10", this, "Fifth" );
   AddComponent( textLabel10 );
   textLabel10.SetWantsMouseNotifications( false );
   textLabel10.SetPosition( 34, 103 );
   textLabel10.SetSize( 29, 20 );
   textLabel10.SetEditable( false, false );
   textLabel10.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel10.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel10.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel10.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel10.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel10.SetBorderSize( 1 );
   textLabel10.SetMultiLineEdit( false );
   textLabel10.SetIsNumberEditor( false );
   textLabel10.SetNumberEditorRange( 0, 100 );
   textLabel10.SetNumberEditorInterval( 1 );
   textLabel10.SetNumberEditorUsesMouseWheel( false );
   textLabel10.SetHasCustomTextHoverColor( false );
   textLabel10.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel10.SetFont( "Verdana", 10, false, false );

   textLabel11 = new VoltageLabel( "textLabel11", "textLabel11", this, "Octave" );
   AddComponent( textLabel11 );
   textLabel11.SetWantsMouseNotifications( false );
   textLabel11.SetPosition( 34, 91 );
   textLabel11.SetSize( 33, 20 );
   textLabel11.SetEditable( false, false );
   textLabel11.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel11.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel11.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel11.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel11.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel11.SetBorderSize( 1 );
   textLabel11.SetMultiLineEdit( false );
   textLabel11.SetIsNumberEditor( false );
   textLabel11.SetNumberEditorRange( 0, 100 );
   textLabel11.SetNumberEditorInterval( 1 );
   textLabel11.SetNumberEditorUsesMouseWheel( false );
   textLabel11.SetHasCustomTextHoverColor( false );
   textLabel11.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel11.SetFont( "Verdana", 10, false, false );

   textLabel12 = new VoltageLabel( "textLabel12", "textLabel12", this, "Fine Tune" );
   AddComponent( textLabel12 );
   textLabel12.SetWantsMouseNotifications( false );
   textLabel12.SetPosition( 77, 75 );
   textLabel12.SetSize( 57, 30 );
   textLabel12.SetEditable( false, false );
   textLabel12.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel12.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel12.SetColor( new Color( 226, 79, 166, 255 ) );
   textLabel12.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel12.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel12.SetBorderSize( 1 );
   textLabel12.SetMultiLineEdit( false );
   textLabel12.SetIsNumberEditor( false );
   textLabel12.SetNumberEditorRange( 0, 100 );
   textLabel12.SetNumberEditorInterval( 1 );
   textLabel12.SetNumberEditorUsesMouseWheel( false );
   textLabel12.SetHasCustomTextHoverColor( false );
   textLabel12.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel12.SetFont( "Verdana", 12, false, false );

   textLabel29 = new VoltageLabel( "textLabel29", "textLabel29", this, "Detune" );
   AddComponent( textLabel29 );
   textLabel29.SetWantsMouseNotifications( false );
   textLabel29.SetPosition( 8, 218 );
   textLabel29.SetSize( 50, 30 );
   textLabel29.SetEditable( false, false );
   textLabel29.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel29.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel29.SetColor( new Color( 226, 79, 166, 255 ) );
   textLabel29.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel29.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel29.SetBorderSize( 1 );
   textLabel29.SetMultiLineEdit( false );
   textLabel29.SetIsNumberEditor( false );
   textLabel29.SetNumberEditorRange( 0, 100 );
   textLabel29.SetNumberEditorInterval( 1 );
   textLabel29.SetNumberEditorUsesMouseWheel( false );
   textLabel29.SetHasCustomTextHoverColor( false );
   textLabel29.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel29.SetFont( "Verdana", 12, false, false );

   knobFineTune = new VoltageKnob( "Fine Tune", "Fine Tune", this, -1, 1, 0 );
   AddComponent( knobFineTune );
   knobFineTune.SetWantsMouseNotifications( false );
   knobFineTune.SetPosition( 89, 98 );
   knobFineTune.SetSize( 33, 33 );
   knobFineTune.SetSkin( "Dial Plum" );
   knobFineTune.SetRange( -1, 1, 0, false, 0 );
   knobFineTune.SetKnobParams( 215, 145 );
   knobFineTune.DisplayValueInPercent( false );
   knobFineTune.SetKnobAdjustsRing( true );
   knobFineTune.SetMidpointValue( 2 );

   knobBeatFreq = new VoltageKnob( "Detune", "Detune", this, -1, 20, 0.1 );
   AddComponent( knobBeatFreq );
   knobBeatFreq.SetWantsMouseNotifications( false );
   knobBeatFreq.SetPosition( 9, 243 );
   knobBeatFreq.SetSize( 49, 49 );
   knobBeatFreq.SetSkin( "Cosmo Large Black" );
   knobBeatFreq.SetRange( -1, 20, 0.1, false, 0 );
   knobBeatFreq.SetKnobParams( 215, 145 );
   knobBeatFreq.DisplayValueInPercent( false );
   knobBeatFreq.SetKnobAdjustsRing( true );
   knobBeatFreq.SetMidpointValue( 0 );

   textLabel13 = new VoltageLabel( "textLabel13", "textLabel13", this, "Osc Mix" );
   AddComponent( textLabel13 );
   textLabel13.SetWantsMouseNotifications( false );
   textLabel13.SetPosition( 77, 223 );
   textLabel13.SetSize( 57, 20 );
   textLabel13.SetEditable( false, false );
   textLabel13.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel13.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel13.SetColor( new Color( 226, 79, 166, 255 ) );
   textLabel13.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel13.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel13.SetBorderSize( 1 );
   textLabel13.SetMultiLineEdit( false );
   textLabel13.SetIsNumberEditor( false );
   textLabel13.SetNumberEditorRange( 0, 100 );
   textLabel13.SetNumberEditorInterval( 1 );
   textLabel13.SetNumberEditorUsesMouseWheel( false );
   textLabel13.SetHasCustomTextHoverColor( false );
   textLabel13.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel13.SetFont( "Verdana", 12, false, false );

   knobMix = new VoltageKnob( "Osc Mix", "Osc Mix", this, -10, 10, 0 );
   AddComponent( knobMix );
   knobMix.SetWantsMouseNotifications( false );
   knobMix.SetPosition( 80, 242 );
   knobMix.SetSize( 51, 51 );
   knobMix.SetSkin( "Dial Black" );
   knobMix.SetRingSkin( "Solid Orange/Grapefruit" );
   knobMix.SetRange( -10, 10, 0, false, 0 );
   knobMix.SetKnobParams( 215, 145 );
   knobMix.DisplayValueInPercent( false );
   knobMix.SetKnobAdjustsRing( false );

   textLabel14 = new VoltageLabel( "textLabel14", "textLabel14", this, "Osc 1" );
   AddComponent( textLabel14 );
   textLabel14.SetWantsMouseNotifications( false );
   textLabel14.SetPosition( 72, 282 );
   textLabel14.SetSize( 31, 19 );
   textLabel14.SetEditable( false, false );
   textLabel14.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel14.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel14.SetColor( new Color( 255, 96, 96, 255 ) );
   textLabel14.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel14.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel14.SetBorderSize( 1 );
   textLabel14.SetMultiLineEdit( false );
   textLabel14.SetIsNumberEditor( false );
   textLabel14.SetNumberEditorRange( 0, 100 );
   textLabel14.SetNumberEditorInterval( 1 );
   textLabel14.SetNumberEditorUsesMouseWheel( false );
   textLabel14.SetHasCustomTextHoverColor( false );
   textLabel14.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel14.SetFont( "Verdana", 10, false, false );

   textLabel15 = new VoltageLabel( "textLabel15", "textLabel15", this, "Osc 2" );
   AddComponent( textLabel15 );
   textLabel15.SetWantsMouseNotifications( false );
   textLabel15.SetPosition( 107, 282 );
   textLabel15.SetSize( 31, 19 );
   textLabel15.SetEditable( false, false );
   textLabel15.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel15.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel15.SetColor( new Color( 248, 150, 65, 255 ) );
   textLabel15.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel15.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel15.SetBorderSize( 1 );
   textLabel15.SetMultiLineEdit( false );
   textLabel15.SetIsNumberEditor( false );
   textLabel15.SetNumberEditorRange( 0, 100 );
   textLabel15.SetNumberEditorInterval( 1 );
   textLabel15.SetNumberEditorUsesMouseWheel( false );
   textLabel15.SetHasCustomTextHoverColor( false );
   textLabel15.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel15.SetFont( "Verdana", 10, false, false );

   switchOsc1Bass = new VoltageSwitch( "Osc 1 Bass", "Osc 1 Bass", this, 1 );
   AddComponent( switchOsc1Bass );
   switchOsc1Bass.SetWantsMouseNotifications( false );
   switchOsc1Bass.SetPosition( 5, 152 );
   switchOsc1Bass.SetSize( 35, 35 );
   switchOsc1Bass.SetSkin( "3-State Bar Vertical" );

   textLabel16 = new VoltageLabel( "textLabel16", "textLabel16", this, "Osc 1 Bass" );
   AddComponent( textLabel16 );
   textLabel16.SetWantsMouseNotifications( false );
   textLabel16.SetPosition( 1, 128 );
   textLabel16.SetSize( 59, 30 );
   textLabel16.SetEditable( false, false );
   textLabel16.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel16.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel16.SetColor( new Color( 226, 79, 166, 255 ) );
   textLabel16.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel16.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel16.SetBorderSize( 1 );
   textLabel16.SetMultiLineEdit( false );
   textLabel16.SetIsNumberEditor( false );
   textLabel16.SetNumberEditorRange( 0, 100 );
   textLabel16.SetNumberEditorInterval( 1 );
   textLabel16.SetNumberEditorUsesMouseWheel( false );
   textLabel16.SetHasCustomTextHoverColor( false );
   textLabel16.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel16.SetFont( "Verdana", 12, false, false );

   textLabel17 = new VoltageLabel( "textLabel17", "textLabel17", this, "Cut" );
   AddComponent( textLabel17 );
   textLabel17.SetWantsMouseNotifications( false );
   textLabel17.SetPosition( 32, 173 );
   textLabel17.SetSize( 34, 20 );
   textLabel17.SetEditable( false, false );
   textLabel17.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel17.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel17.SetColor( new Color( 167, 0, 215, 255 ) );
   textLabel17.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel17.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel17.SetBorderSize( 1 );
   textLabel17.SetMultiLineEdit( false );
   textLabel17.SetIsNumberEditor( false );
   textLabel17.SetNumberEditorRange( 0, 100 );
   textLabel17.SetNumberEditorInterval( 1 );
   textLabel17.SetNumberEditorUsesMouseWheel( false );
   textLabel17.SetHasCustomTextHoverColor( false );
   textLabel17.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel17.SetFont( "Verdana", 10, false, false );

   textLabel18 = new VoltageLabel( "textLabel18", "textLabel18", this, "Norm" );
   AddComponent( textLabel18 );
   textLabel18.SetWantsMouseNotifications( false );
   textLabel18.SetPosition( 32, 160 );
   textLabel18.SetSize( 29, 19 );
   textLabel18.SetEditable( false, false );
   textLabel18.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel18.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel18.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel18.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel18.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel18.SetBorderSize( 1 );
   textLabel18.SetMultiLineEdit( false );
   textLabel18.SetIsNumberEditor( false );
   textLabel18.SetNumberEditorRange( 0, 100 );
   textLabel18.SetNumberEditorInterval( 1 );
   textLabel18.SetNumberEditorUsesMouseWheel( false );
   textLabel18.SetHasCustomTextHoverColor( false );
   textLabel18.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel18.SetFont( "Verdana", 10, false, false );

   textLabel19 = new VoltageLabel( "textLabel19", "textLabel19", this, "Boost" );
   AddComponent( textLabel19 );
   textLabel19.SetWantsMouseNotifications( false );
   textLabel19.SetPosition( 32, 146 );
   textLabel19.SetSize( 33, 20 );
   textLabel19.SetEditable( false, false );
   textLabel19.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel19.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel19.SetColor( new Color( 235, 0, 109, 255 ) );
   textLabel19.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel19.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel19.SetBorderSize( 1 );
   textLabel19.SetMultiLineEdit( false );
   textLabel19.SetIsNumberEditor( false );
   textLabel19.SetNumberEditorRange( 0, 100 );
   textLabel19.SetNumberEditorInterval( 1 );
   textLabel19.SetNumberEditorUsesMouseWheel( false );
   textLabel19.SetHasCustomTextHoverColor( false );
   textLabel19.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel19.SetFont( "Verdana", 10, false, false );

   switchOsc2Bass = new VoltageSwitch( "Osc 2 Bass", "Osc 2 Bass", this, 1 );
   AddComponent( switchOsc2Bass );
   switchOsc2Bass.SetWantsMouseNotifications( false );
   switchOsc2Bass.SetPosition( 87, 152 );
   switchOsc2Bass.SetSize( 35, 35 );
   switchOsc2Bass.SetSkin( "3-State Bar Vertical" );

   textLabel20 = new VoltageLabel( "textLabel20", "textLabel20", this, "Osc 2 Bass" );
   AddComponent( textLabel20 );
   textLabel20.SetWantsMouseNotifications( false );
   textLabel20.SetPosition( 82, 128 );
   textLabel20.SetSize( 59, 30 );
   textLabel20.SetEditable( false, false );
   textLabel20.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel20.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel20.SetColor( new Color( 226, 79, 166, 255 ) );
   textLabel20.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel20.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel20.SetBorderSize( 1 );
   textLabel20.SetMultiLineEdit( false );
   textLabel20.SetIsNumberEditor( false );
   textLabel20.SetNumberEditorRange( 0, 100 );
   textLabel20.SetNumberEditorInterval( 1 );
   textLabel20.SetNumberEditorUsesMouseWheel( false );
   textLabel20.SetHasCustomTextHoverColor( false );
   textLabel20.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel20.SetFont( "Verdana", 12, false, false );

   textLabel21 = new VoltageLabel( "textLabel21", "textLabel21", this, "Cut" );
   AddComponent( textLabel21 );
   textLabel21.SetWantsMouseNotifications( false );
   textLabel21.SetPosition( 114, 173 );
   textLabel21.SetSize( 20, 20 );
   textLabel21.SetEditable( false, false );
   textLabel21.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel21.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel21.SetColor( new Color( 167, 0, 215, 255 ) );
   textLabel21.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel21.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel21.SetBorderSize( 1 );
   textLabel21.SetMultiLineEdit( false );
   textLabel21.SetIsNumberEditor( false );
   textLabel21.SetNumberEditorRange( 0, 100 );
   textLabel21.SetNumberEditorInterval( 1 );
   textLabel21.SetNumberEditorUsesMouseWheel( false );
   textLabel21.SetHasCustomTextHoverColor( false );
   textLabel21.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel21.SetFont( "Verdana", 10, false, false );

   textLabel22 = new VoltageLabel( "textLabel22", "textLabel22", this, "Norm" );
   AddComponent( textLabel22 );
   textLabel22.SetWantsMouseNotifications( false );
   textLabel22.SetPosition( 114, 160 );
   textLabel22.SetSize( 26, 19 );
   textLabel22.SetEditable( false, false );
   textLabel22.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel22.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel22.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel22.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel22.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel22.SetBorderSize( 1 );
   textLabel22.SetMultiLineEdit( false );
   textLabel22.SetIsNumberEditor( false );
   textLabel22.SetNumberEditorRange( 0, 100 );
   textLabel22.SetNumberEditorInterval( 1 );
   textLabel22.SetNumberEditorUsesMouseWheel( false );
   textLabel22.SetHasCustomTextHoverColor( false );
   textLabel22.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel22.SetFont( "Verdana", 10, false, false );

   textLabel23 = new VoltageLabel( "textLabel23", "textLabel23", this, "Boost" );
   AddComponent( textLabel23 );
   textLabel23.SetWantsMouseNotifications( false );
   textLabel23.SetPosition( 114, 146 );
   textLabel23.SetSize( 26, 20 );
   textLabel23.SetEditable( false, false );
   textLabel23.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel23.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel23.SetColor( new Color( 235, 0, 109, 255 ) );
   textLabel23.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel23.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel23.SetBorderSize( 1 );
   textLabel23.SetMultiLineEdit( false );
   textLabel23.SetIsNumberEditor( false );
   textLabel23.SetNumberEditorRange( 0, 100 );
   textLabel23.SetNumberEditorInterval( 1 );
   textLabel23.SetNumberEditorUsesMouseWheel( false );
   textLabel23.SetHasCustomTextHoverColor( false );
   textLabel23.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel23.SetFont( "Verdana", 10, false, false );

   outputAudio = new VoltageAudioJack( "Audio Output", "Audio Output", this, JackType.JackType_AudioOutput );
   AddComponent( outputAudio );
   outputAudio.SetWantsMouseNotifications( false );
   outputAudio.SetPosition( 113, 314 );
   outputAudio.SetSize( 25, 25 );
   outputAudio.SetSkin( "Jack Round Red Ring" );

   inputVOct = new VoltageAudioJack( "V/Oct Input", "V/Oct Input", this, JackType.JackType_AudioInput );
   AddComponent( inputVOct );
   inputVOct.SetWantsMouseNotifications( false );
   inputVOct.SetPosition( 5, 314 );
   inputVOct.SetSize( 25, 25 );
   inputVOct.SetSkin( "Jack Round 25px" );

   textLabel24 = new VoltageLabel( "textLabel24", "textLabel24", this, "V/Oct" );
   AddComponent( textLabel24 );
   textLabel24.SetWantsMouseNotifications( false );
   textLabel24.SetPosition( 0, 294 );
   textLabel24.SetSize( 34, 21 );
   textLabel24.SetEditable( false, false );
   textLabel24.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel24.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel24.SetColor( new Color( 255, 96, 96, 255 ) );
   textLabel24.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel24.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel24.SetBorderSize( 1 );
   textLabel24.SetMultiLineEdit( false );
   textLabel24.SetIsNumberEditor( false );
   textLabel24.SetNumberEditorRange( 0, 100 );
   textLabel24.SetNumberEditorInterval( 1 );
   textLabel24.SetNumberEditorUsesMouseWheel( false );
   textLabel24.SetHasCustomTextHoverColor( false );
   textLabel24.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel24.SetFont( "Verdana", 12, false, false );

   textLabel25 = new VoltageLabel( "textLabel25", "textLabel25", this, "Out" );
   AddComponent( textLabel25 );
   textLabel25.SetWantsMouseNotifications( false );
   textLabel25.SetPosition( 110, 294 );
   textLabel25.SetSize( 32, 21 );
   textLabel25.SetEditable( false, false );
   textLabel25.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel25.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel25.SetColor( new Color( 255, 96, 96, 255 ) );
   textLabel25.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel25.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel25.SetBorderSize( 1 );
   textLabel25.SetMultiLineEdit( false );
   textLabel25.SetIsNumberEditor( false );
   textLabel25.SetNumberEditorRange( 0, 100 );
   textLabel25.SetNumberEditorInterval( 1 );
   textLabel25.SetNumberEditorUsesMouseWheel( false );
   textLabel25.SetHasCustomTextHoverColor( false );
   textLabel25.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel25.SetFont( "Verdana", 12, false, false );

   textLabel30 = new VoltageLabel( "textLabel30", "textLabel30", this, "Sync" );
   AddComponent( textLabel30 );
   textLabel30.SetWantsMouseNotifications( false );
   textLabel30.SetPosition( 28, 200 );
   textLabel30.SetSize( 37, 21 );
   textLabel30.SetEditable( false, false );
   textLabel30.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel30.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel30.SetColor( new Color( 248, 150, 65, 255 ) );
   textLabel30.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel30.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel30.SetBorderSize( 1 );
   textLabel30.SetMultiLineEdit( false );
   textLabel30.SetIsNumberEditor( false );
   textLabel30.SetNumberEditorRange( 0, 100 );
   textLabel30.SetNumberEditorInterval( 1 );
   textLabel30.SetNumberEditorUsesMouseWheel( false );
   textLabel30.SetHasCustomTextHoverColor( false );
   textLabel30.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel30.SetFont( "Verdana", 12, false, false );

   textLabel26 = new VoltageLabel( "textLabel26", "textLabel26", this, "CV" );
   AddComponent( textLabel26 );
   textLabel26.SetWantsMouseNotifications( false );
   textLabel26.SetPosition( 36, 294 );
   textLabel26.SetSize( 35, 21 );
   textLabel26.SetEditable( false, false );
   textLabel26.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel26.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel26.SetColor( new Color( 255, 96, 96, 255 ) );
   textLabel26.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel26.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel26.SetBorderSize( 1 );
   textLabel26.SetMultiLineEdit( false );
   textLabel26.SetIsNumberEditor( false );
   textLabel26.SetNumberEditorRange( 0, 100 );
   textLabel26.SetNumberEditorInterval( 1 );
   textLabel26.SetNumberEditorUsesMouseWheel( false );
   textLabel26.SetHasCustomTextHoverColor( false );
   textLabel26.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel26.SetFont( "Verdana", 12, false, false );

   inputPitchCV = new VoltageAudioJack( "Pitch CV Input", "Pitch CV Input", this, JackType.JackType_AudioInput );
   AddComponent( inputPitchCV );
   inputPitchCV.SetWantsMouseNotifications( false );
   inputPitchCV.SetPosition( 41, 314 );
   inputPitchCV.SetSize( 25, 25 );
   inputPitchCV.SetSkin( "Jack Round Orange Ring" );

   knobPitchMod = new VoltageKnob( "Pitch Mod Depth", "Pitch Mod Depth", this, 0, 12, 0 );
   AddComponent( knobPitchMod );
   knobPitchMod.SetWantsMouseNotifications( false );
   knobPitchMod.SetPosition( 74, 313 );
   knobPitchMod.SetSize( 30, 30 );
   knobPitchMod.SetSkin( "Plastic White" );
   knobPitchMod.SetRingSkin( "Ramp Red/Pink" );
   knobPitchMod.SetRange( 0, 12, 0, false, 0 );
   knobPitchMod.SetKnobParams( 215, 145 );
   knobPitchMod.DisplayValueInPercent( false );
   knobPitchMod.SetKnobAdjustsRing( true );
   knobPitchMod.SetMidpointValue( 2 );

   textLabel27 = new VoltageLabel( "textLabel27", "textLabel27", this, "Depth" );
   AddComponent( textLabel27 );
   textLabel27.SetWantsMouseNotifications( false );
   textLabel27.SetPosition( 69, 294 );
   textLabel27.SetSize( 39, 21 );
   textLabel27.SetEditable( false, false );
   textLabel27.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel27.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel27.SetColor( new Color( 255, 96, 96, 255 ) );
   textLabel27.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel27.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel27.SetBorderSize( 1 );
   textLabel27.SetMultiLineEdit( false );
   textLabel27.SetIsNumberEditor( false );
   textLabel27.SetNumberEditorRange( 0, 100 );
   textLabel27.SetNumberEditorInterval( 1 );
   textLabel27.SetNumberEditorUsesMouseWheel( false );
   textLabel27.SetHasCustomTextHoverColor( false );
   textLabel27.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel27.SetFont( "Verdana", 12, false, false );

   textLabel28 = new VoltageLabel( "textLabel28", "textLabel28", this, "Bass Oscillators" );
   AddComponent( textLabel28 );
   textLabel28.SetWantsMouseNotifications( false );
   textLabel28.SetPosition( 3, 13 );
   textLabel28.SetSize( 139, 17 );
   textLabel28.SetEditable( false, false );
   textLabel28.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel28.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel28.SetColor( new Color( 171, 137, 180, 255 ) );
   textLabel28.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel28.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel28.SetBorderSize( 1 );
   textLabel28.SetMultiLineEdit( false );
   textLabel28.SetIsNumberEditor( false );
   textLabel28.SetNumberEditorRange( 0, 100 );
   textLabel28.SetNumberEditorInterval( 1 );
   textLabel28.SetNumberEditorUsesMouseWheel( false );
   textLabel28.SetHasCustomTextHoverColor( false );
   textLabel28.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel28.SetFont( "Verdana", 14, true, false );

   switchInvert = new VoltageSwitch( "Osc 2 Shape", "Osc 2 Shape", this, 0 );
   AddComponent( switchInvert );
   switchInvert.SetWantsMouseNotifications( false );
   switchInvert.SetPosition( 101, 199 );
   switchInvert.SetSize( 26, 26 );
   switchInvert.SetSkin( "2-State Bar Horizontal" );

   inputSync = new VoltageAudioJack( "Sync Input", "Sync Input", this, JackType.JackType_AudioInput );
   AddComponent( inputSync );
   inputSync.SetWantsMouseNotifications( false );
   inputSync.SetPosition( 5, 198 );
   inputSync.SetSize( 25, 25 );
   inputSync.SetSkin( "Jack Round Orange Ring" );

   knobPhase = new VoltageKnob( "Sync Phase Offset", "Sync Phase Offset", this, 0.0, 360, 0 );
   AddComponent( knobPhase );
   knobPhase.SetWantsMouseNotifications( false );
   knobPhase.SetPosition( 63, 203 );
   knobPhase.SetSize( 22, 22 );
   knobPhase.SetSkin( "Plastic Orange" );
   knobPhase.SetRange( 0.0, 360, 0, false, 0 );
   knobPhase.SetKnobParams( 215, 145 );
   knobPhase.DisplayValueInPercent( false );
   knobPhase.SetKnobAdjustsRing( true );

   textLabel32 = new VoltageLabel( "textLabel32", "textLabel32", this, "Wave" );
   AddComponent( textLabel32 );
   textLabel32.SetWantsMouseNotifications( false );
   textLabel32.SetPosition( 96, 184 );
   textLabel32.SetSize( 35, 23 );
   textLabel32.SetEditable( false, false );
   textLabel32.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel32.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel32.SetColor( new Color( 248, 150, 65, 255 ) );
   textLabel32.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel32.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel32.SetBorderSize( 1 );
   textLabel32.SetMultiLineEdit( false );
   textLabel32.SetIsNumberEditor( false );
   textLabel32.SetNumberEditorRange( 0, 100 );
   textLabel32.SetNumberEditorInterval( 1 );
   textLabel32.SetNumberEditorUsesMouseWheel( false );
   textLabel32.SetHasCustomTextHoverColor( false );
   textLabel32.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel32.SetFont( "Verdana", 12, false, false );
}



//-------------------------------------------------------------------------------
//  public void Initialize()

//  Initialize will get called shortly after your module's constructor runs. You can use it to
//  do any initialization that the auto-generated code doesn't handle.
//-------------------------------------------------------------------------------
@Override
public void Initialize()
{
   //[user-Initialize]   Add your own initialization code here

   previousLogVoltage = -100.0f;
   Osc1.SetFrequency(LOWEST_C_FREQ);
   Osc2.SetFrequency(LOWEST_C_FREQ);
   Osc1.SetDriftAmount(0.0);
   Osc2.SetDriftAmount(0.0);
   
   smoothBeatFreq.SetValue(knobBeatFreq.GetValue());
   smoothMix.SetValue(knobMix.GetValue());
   smoothFineTune.SetValue(knobFineTune.GetValue());
   smoothPitchMod.SetValue(knobPitchMod.GetValue());
   smoothPhase.SetValue(knobPhase.GetValue());
   
   ReadOctaveSwitch (switchOctave.GetValue());
   ReadIntervalSwitch (switchInterval.GetValue());
   ReadOsc1BassSwitch (switchOsc1Bass.GetValue());
   ReadOsc2BassSwitch (switchOsc2Bass.GetValue());
   ReadOsc2InvertSwitch (switchInvert.GetValue());   

   //[/user-Initialize]
}


//-------------------------------------------------------------------------------
//  public void Destroy()

//  Destroy will get called just before your module gets deleted. You can use it to perform any
//  cleanup that's not handled automatically by Java.
//-------------------------------------------------------------------------------
@Override
public void Destroy()
{
   super.Destroy();
   //[user-Destroy]   Add your own module-getting-deleted code here



   //[/user-Destroy]
}


//-------------------------------------------------------------------------------
//  public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )

//  Notify will get called when various events occur - control values changing, timers firing, etc.
//-------------------------------------------------------------------------------
@Override
public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )
{
   //[user-Notify]   Add your own notification handling code between this line and the notify-close comment
   switch( notification )
   {
      case Knob_Changed:   // doubleValue is the new VoltageKnob value
      {
         if (component == knobBeatFreq)
         {
            smoothBeatFreq.SetValue(doubleValue);
         }
         else if (component == knobMix)
         {
            smoothMix.SetValue(doubleValue);
         }
         else if (component == knobFineTune)
         {
            smoothFineTune.SetValue(doubleValue);
         }
         else if (component == knobPitchMod)
         {
            smoothPitchMod.SetValue(doubleValue);
         }
         else if (component == knobPhase)
         {
            smoothPhase.SetValue(doubleValue);
         }
      }
      break;
   
      case Slider_Changed:   // doubleValue is the new slider value
      {
      }
      break;
   
      case Button_Changed:   // doubleValue is the new button/toggle button value
      {
      }
      break;
   
      case Switch_Changed:   // doubleValue is the new switch value
      {
         if (component == switchOctave)
         {
            ReadOctaveSwitch (doubleValue);
         }
         else if (component == switchInterval)
         {
            ReadIntervalSwitch (doubleValue);
         }
         else if (component == switchOsc1Bass)
         {
            ReadOsc1BassSwitch (doubleValue);
         }
         else if (component == switchOsc2Bass)
         {
            ReadOsc2BassSwitch (doubleValue);
         }
         else if (component == switchInvert)
         {
            ReadOsc2InvertSwitch (doubleValue);
         }
      }
      break;
   
      case Jack_Connected:   // longValue is the new cable ID
      {
         CheckConnections();
      }
      break;
   
      case Jack_Disconnected:   // All cables have been disconnected from this jack
      {
         CheckConnections();
      }
      break;
   
      case GUI_Update_Timer:   // Called every 50ms (by default) if turned on
      {
      }
      break;
   
      case Object_MouseMove:   // called when mouse is over an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_MouseLeave:  // called when mouse leaves an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonDown:   // called when user left-clicks on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonUp:   // called when user releases left mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonDown:   // called when user releases right mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonUp:   // called when user right-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      case Object_LeftButtonDoubleClick: // called when user left-button double-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      // Less common notifications:
   
      case Named_Timer:   // object contains a String with the name of the timer that has fired
      {
      }
      break;
   
      case Canvas_Painting:   // About to paint canvas.  object is a java.awt.Rectangle with painting boundaries
      {
      }
      break;
   
      case Canvas_Painted:   // Canvas painting is complete
      {
      }
      break;
   
      case Control_DragStart:    // A user has started dragging on a control that has been marked as draggable
      {
      }
      break;
   
      case Control_DragOn:       // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragOff:      // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragEnd:      // A user has ended their drag on a control that has been marked as draggable
      {
      }
      break;
   
      case Label_Changed:        // The text of an editable text control has changed
      {
      }
      break;
   
      case SoundPlayback_Start:   // A sound has begun playback
      {
      }
      break;
   
      case SoundPlayback_End:     // A sound has ended playback
      {
      }
      break;
   
      case Scrollbar_Position:    // longValue is the new scrollbar position
      {
      }
      break;
   
      case PolyVoices_Changed:    // longValue is the new number of poly voices
      {
      }
      break;
   
      case File_Dropped:     // 'object' is a String containing the file path
      {
      }
      break;
   
      case Preset_Loading_Start:   // called when preset loading begins
      {
      }
      break;
   
      case Preset_Loading_Finish:  // called when preset loading finishes
      {
      }
      break;
   
      case Variation_Loading_Start:    // sent when a variation is about to load
      {
      }
      break;
   
      case Variation_Loading_Finish:   // sent when a variation has just finished loading
      {
      }
      break;
   
      case Tempo_Changed:     // doubleValue is the new tempo
      {
      }
      break;
   
      case Randomized:     // called when the module's controls get randomized
      {
      }
      break;
   
      case VariationListChanged:   // sent when a variation gets added, deleted, or renamed, or the variations list gets reordered
      {
      }
      break;
   
      case Key_Press:     // sent when module has keyboard focus and a key is pressed; object is a VoltageKeyPressInfo object
      {
      }
      break;
   
      case Reset:    // sent when the module has been reset to default settings
      {
      }
      break;
   
      case Keyboard_NoteOn:   // sent when a note has been pressed on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Keyboard_NoteOff:   // sent when a note has been released on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Curve_Changed:   // sent when user has edited a curve's value. 'object' will be a VoltageCurve.CurveChangeNotification object.
      {
      }
      break;
   }



   return false;
   //[/user-Notify]
}


//-------------------------------------------------------------------------------
//  public void ProcessSample()

//  ProcessSample is called once per sample. Usually it's where you read
//  from input jacks, process audio, and write it to your output jacks.
//  Since ProcesssSample gets called 48,000 times per second, offload CPU-intensive operations
//  to other threads when possible and avoid calling native functions.
//-------------------------------------------------------------------------------
@Override
public void ProcessSample()
{
   //[user-ProcessSample]   Add your own process-sampling code here

   double outputValue;
   
   double tempDouble;
   double smoothedPhase;
   double osc1output;
   double osc2output;
   double osc1amplitude;
   double osc2amplitude;
   double doubleLinearFrequency;
   double audioOutput;
   
   float  currentInputVoltage;
   float  currentLinearFrequency;
   float  tempfloat;
   
   if (outputConnected)
   {
      // Get keyboard 1V/Oct input
      currentInputVoltage = (float)inputVOct.GetValue();
      
      // Apply transpose and fine tuning
      currentInputVoltage += octaveVolts;
      tempfloat = (float)knobSemitone.GetValue() +
                  (float)smoothFineTune.GetSmoothValue();
      currentInputVoltage += tempfloat * VOLTS_PER_SEMITONE;                                   
      
      // Calculate CV Contribution
      tempfloat = (float)smoothPitchMod.GetSmoothValue() *
                  (float)inputPitchCV.GetValue() *
                  VOLTS_PER_SEMITONE * FIVE_VOLTS_ATTEN;
      currentInputVoltage += tempfloat;
      
      // Check if pitch voltage has changed since previous sample
      if (currentInputVoltage != previousLogVoltage)
      {
         currentLinearFrequency = LOWEST_C_FREQ *
                                  Values.FastTwoToTheX(currentInputVoltage);
         previousLogVoltage = currentInputVoltage;
         previousLinearFreq = currentLinearFrequency;
      }
      
      doubleLinearFrequency = (double)previousLinearFreq;
      
      // Find detune beat frequency and apply to both oscs    
      tempDouble = smoothBeatFreq.GetSmoothValue() * 0.5;
      Osc1.SetFrequency (doubleLinearFrequency + tempDouble);
      Osc2.SetFrequency (doubleLinearFrequency * intervalMultiplier - tempDouble);
      
      smoothedPhase = smoothPhase.GetSmoothValue();
      
      // Check for Sync Input rising edge
      if (syncConnected)
      {
         syncHigh = (inputSync.GetValue() > 0.0);
         if (syncHigh && !syncHighPrevious)
         {
            // Reset phases of Osc 1 to 0            
            Osc1.ResetCycle();
            
            // Reset phases of Osc 2 to Phase knob setting
            Osc2.SetCycle(smoothedPhase * PHASE_MULTIPLIER);
         }
         syncHighPrevious = syncHigh;
      }
      
      // Now that frequencies are set, advance pointer
      Osc1.AdvanceSample();
      Osc2.AdvanceSample();
      
      // Calculate waveforms from Osc1 and Osc2
      osc1output = Osc1.GetSawtoothValue() +
                   Osc1.GetPureSineValue() *
                   osc1SineAmplitude;
                    
      osc2output = Osc2.GetSawtoothValue() +
                   Osc2.GetPureSineValue() *
                   osc2SineAmplitude;

      // Find mix value and adapt to range 0.0 to 1.0
      osc2amplitude = (smoothMix.GetSmoothValue() + 10.0) * 0.05;
      osc1amplitude = 1.0 - osc2amplitude;
      
      // Perform mixing and output
      outputAudio.SetValue(osc1output * osc1amplitude +
                           osc2output * osc2amplitude * osc2Invert);
   }
   else
   {
      outputAudio.SetValue(0.0);
   }

   //[/user-ProcessSample]
}


//-------------------------------------------------------------------------------
//  public void ProcessBypassedSample()

//  ProcessBypassedSample gets called instead of ProcessSample when you've checked the "Can Be Bypassed" box
//  and a user has bypassed your module. If your module processes data from input jacks and then sends it to
//  output jack(s), make ProcessBypassedSample just send the data from the input jacks to the output jacks without
//  processing it.
//-------------------------------------------------------------------------------
@Override
public void ProcessBypassedSample()
{
   //[user-ProcessBypassedSample]   Add your own code here

   outputAudio.SetValue(0.0);


   //[/user-ProcessBypassedSample]
}


//-------------------------------------------------------------------------------
//  public String GetTooltipText( VoltageComponent component )

//  Gets called when a tooltip is about to display for a control. Override it if
//  you want to change what the tooltip displays - if you want a knob to work in logarithmic fashion,
//  for instance, you can translate the knob's current value to a log-based string and display it here.
//-------------------------------------------------------------------------------
@Override
public String GetTooltipText( VoltageComponent component )
{
   //[user-GetTooltipText]   Add your own code here



   return super.GetTooltipText( component );
   //[/user-GetTooltipText]
}


//-------------------------------------------------------------------------------
//  public void EditComponentValue( VoltageComponent component, double newValue, String newText )

//  Gets called after a user clicks on a tooltip and types in a new value for a control. Override this if
//  you've changed the default tooltip display (translating a linear value to logarithmic, for instance)
//  in GetTooltipText().
//-------------------------------------------------------------------------------
@Override
public void EditComponentValue( VoltageComponent component, double newValue, String newText )
{
   //[user-EditComponentValue]   Add your own code here



   //[/user-EditComponentValue]
   super.EditComponentValue( component, newValue, newText );
}


//-------------------------------------------------------------------------------
//  public void OnUndoRedo( String undoType, double newValue, Object optionalObject )

//  If you've created custom undo events via calls to CreateUndoEvent, you'll need to
//  process them in this function when they get triggered by undo/redo actions.
//-------------------------------------------------------------------------------
@Override
public void OnUndoRedo( String undoType, double newValue, Object optionalObject )
{
   //[user-OnUndoRedo]   Add your own code here



   //[/user-OnUndoRedo]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformation()

//  Gets called when the module's state gets saved, typically when the user saves a preset with
//  this module in it. Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformation()
{
   //[user-GetStateInformation]   Add your own code here



   return null;
   //[/user-GetStateInformation]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformation(byte[] stateInfo)

//  Gets called when this module's state is getting restored, typically when a user opens a preset with
//  this module in it. The stateInfo parameter will contain whatever custom data you stored in GetStateInformation().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformation(byte[] stateInfo)
{
   //[user-SetStateInformation]   Add your own code here



   //[/user-SetStateInformation]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformationForVariations()

//  Gets called when a user saves a variation with this module in it.
//  Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformationForVariations()
{
   //[user-GetStateInformationForVariations]   Add your own code here



   return GetStateInformation();
   //[/user-GetStateInformationForVariations]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformationForVariations(byte[] stateInfo)

//  Gets called when a user loads a variation with this module in it.
//  The stateInfo parameter will contain whatever custom data you stored in GetStateInformationForVariations().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformationForVariations(byte[] stateInfo)
{
   //[user-SetStateInformationForVariations]   Add your own code here
   SetStateInformation(stateInfo);



   //[/user-SetStateInformationForVariations]
}


// Auto-generated variables
private VoltageLabel textLabel32;
private VoltageKnob knobPhase;
private VoltageAudioJack inputSync;
private VoltageSwitch switchInvert;
private VoltageLabel textLabel28;
private VoltageLabel textLabel27;
private VoltageKnob knobPitchMod;
private VoltageAudioJack inputPitchCV;
private VoltageLabel textLabel26;
private VoltageLabel textLabel30;
private VoltageLabel textLabel25;
private VoltageLabel textLabel24;
private VoltageAudioJack inputVOct;
private VoltageAudioJack outputAudio;
private VoltageLabel textLabel23;
private VoltageLabel textLabel22;
private VoltageLabel textLabel21;
private VoltageLabel textLabel20;
private VoltageSwitch switchOsc2Bass;
private VoltageLabel textLabel19;
private VoltageLabel textLabel18;
private VoltageLabel textLabel17;
private VoltageLabel textLabel16;
private VoltageSwitch switchOsc1Bass;
private VoltageLabel textLabel15;
private VoltageLabel textLabel14;
private VoltageKnob knobMix;
private VoltageLabel textLabel13;
private VoltageKnob knobBeatFreq;
private VoltageKnob knobFineTune;
private VoltageLabel textLabel29;
private VoltageLabel textLabel12;
private VoltageLabel textLabel11;
private VoltageLabel textLabel10;
private VoltageLabel textLabel9;
private VoltageLabel textLabel8;
private VoltageSwitch switchInterval;
private VoltageLabel textLabel7;
private VoltageKnob knobSemitone;
private VoltageLabel textLabel6;
private VoltageLabel textLabel5;
private VoltageLabel textLabel4;
private VoltageLabel textLabel31;
private VoltageLabel textLabel3;
private VoltageSwitch switchOctave;
private VoltageLabel textLabel2;
private VoltageLabel textLabel1;


//[user-code-and-variables]    Add your own variables and functions here


// Constants

private final float FIVE_VOLTS_ATTEN = 0.2f;
private final float LOWEST_C_FREQ = 32.703f;
private final float SEMITONES_PER_OCTAVE = 12.0f;
private final float VOLTS_PER_SEMITONE = 1.0f / SEMITONES_PER_OCTAVE;

private final double UNISON_MULTIPLIER = 1.0;
private final double FIFTH_MULTIPLIER = 1.5;
private final double OCTAVE_MULTIPLIER = 2.0;

private final double PHASE_MULTIPLIER = 1.0 / 360.0;


// Types


// Objects

private SmoothValue smoothFineTune = new SmoothValue();
private SmoothValue smoothBeatFreq = new SmoothValue();
private SmoothValue smoothMix      = new SmoothValue();
private SmoothValue smoothPitchMod = new SmoothValue();
private SmoothValue smoothPhase    = new SmoothValue();

private AnalogOscillator Osc1 = new AnalogOscillator();
private AnalogOscillator Osc2 = new AnalogOscillator();


// Variables

private float octaveVolts;
private float semitoneVolts;
private double intervalMultiplier;
private double osc1SineAmplitude;
private double osc2SineAmplitude;
private double osc2Invert;
private boolean outputConnected;
private boolean syncConnected;
private boolean syncHigh;
private boolean syncHighPrevious;
private float previousLogVoltage;
private float previousLinearFreq;


// Functions

private void CheckConnections()
{
   outputConnected = outputAudio.IsConnected();
   syncConnected = inputSync.IsConnected();
   
   syncHigh = false;
   syncHighPrevious = false;
}

private void ReadOctaveSwitch(double octave)
{
   // 0.0 = 32', 1.0 = 16', 2.0 = 32'
   octaveVolts = (float)octave;
}

private void ReadIntervalSwitch(double interval)
{
   if (interval == 0.0)
   {
      // Unison
      intervalMultiplier = UNISON_MULTIPLIER;
   }
   else if (interval == 1.0)
   {
      // Perfect Fifth
      intervalMultiplier = FIFTH_MULTIPLIER;
   }
   else
   {
      // Octave
      intervalMultiplier = OCTAVE_MULTIPLIER;
   }
}

private void ReadOsc1BassSwitch(double osc1bass)
{
   if (osc1bass == 0.0)
   {
      // Cut
      osc1SineAmplitude = -0.5;
   }
   else if (osc1bass == 1.0)
   {
      // Norm
      osc1SineAmplitude = 0.0;
   }
   else
   {
      // Boost
      osc1SineAmplitude = 0.5;
   }
}

private void ReadOsc2BassSwitch(double osc2bass)
{
   if (osc2bass == 0.0)
   {
      // Cut
      osc2SineAmplitude = -0.5;
   }
   else if (osc2bass == 1.0)
   {
      // Norm
      osc2SineAmplitude = 0.0;
   }
   else
   {
      // Boost
      osc2SineAmplitude = 0.5;
   }
}

private void ReadOsc2InvertSwitch(double invert)
{
   if (invert == 0.0)
   {
      // Falling sawtooth
      osc2Invert = 1.0;
   }
   else
   {
      // Rising sawtooth
      osc2Invert = -1.0;
   }
}


//[/user-code-and-variables]
}

 